SystemOrganization addCategory: #Albatross!
SystemOrganization addCategory: #'Albatross-Tests'!

!String methodsFor: '*Albatross' stamp: 'al 10/28/2006 15:56'!
asBoolean
	^Boolean readFrom: self! !

WAEntryPoint subclass: #ARequestHandler
	instanceVariableNames: 'inQueue outQueue browser'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Albatross'!

!ARequestHandler commentStamp: 'pmm 1/3/2008 16:36' prior: 0!
I am the Seaside request handler who handles the http requests and responses. I take the test tasks from the outQueue, where the ABrowser has put them, and send them away as http response. I receive the test results in http requests and pass them to the inQueue, where the ABrowser takes them!

!ARequestHandler class methodsFor: 'accessing' stamp: 'pmm 1/3/2008 15:41'!
default
	^Default ifNil: [
		Default := self named: 'driver'.
		WADispatcher default register: Default ]! !

!ARequestHandler class methodsFor: 'accessing' stamp: 'al 1/5/2008 17:02'!
timeout
	^ ABrowser timeout! !

!ARequestHandler methodsFor: 'accessing' stamp: 'pmm 1/3/2008 15:25'!
browser
	^browser! !

!ARequestHandler methodsFor: 'accessing' stamp: 'pmm 1/3/2008 15:42'!
defaultResponse
	^WAResponse new! !

!ARequestHandler methodsFor: 'request handling' stamp: 'pmm 1/3/2008 15:42'!
handleRequest: aRequest
	| result |
	result := aRequest at: 'result' ifAbsent: nil.
	result notNil
		ifTrue: [
			inQueue nextPut: result.
			^self reply: self nextOrTimeout ]
		ifFalse: [
			(aRequest includesKey: 'start' ) ifTrue: [
				inQueue nextPut: 'true'.
				^self reply: self nextOrTimeout ] ].
	^self defaultResponse! !

!ARequestHandler methodsFor: 'initialize' stamp: 'pmm 1/3/2008 16:36'!
initialize
	super initialize.
	self reset
! !

!ARequestHandler methodsFor: 'request handling' stamp: 'pmm 1/3/2008 16:13'!
nextOrTimeout
	| semaphore task process |
	semaphore := Semaphore new.
	process := [
		task := outQueue next.
		semaphore signal ] fork.
	semaphore waitTimeoutSeconds: self class timeout.
	task ifNil: [
		process terminate.
		self error: self name, ' timed out' ].
	^task! !

!ARequestHandler methodsFor: 'request handling' stamp: 'al 1/6/2008 16:11'!
reply: aString
	^WAResponse
		document: aString
		mimeType: 'text/javascript'! !

!ARequestHandler methodsFor: 'request handling' stamp: 'pmm 1/3/2008 15:25'!
reset
	inQueue := SharedQueue new.
	outQueue := SharedQueue new.
	browser := ABrowser inQueue: inQueue outQueue: outQueue.! !

WAFileLibrary subclass: #ALibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Albatross'!

!ALibrary commentStamp: '<historical>' prior: 0!
I am the Albatross library.!

!ALibrary methodsFor: 'accessing-scripts' stamp: 'al 1/5/2008 20:51'!
clickJs
	^ '/*
  Returns all links or buttons inside the element scope 
*/
function clickableIn1(scope) {
	clickable = (new Selector("a")).findElements(scope);
	clickable = clickable.concat((new Selector("input[type=submit]")).findElements(scope));
	clickable = clickable.concat((new Selector("input[type=reset]")).findElements(scope));
	clickable = clickable.concat((new Selector("button")).findElements(scope));
	return clickable;
}

/*
  Gives all links or buttons of the array 
*/
function clickableIn(array) {
    return array.select(function(each) {
		return isLink(each) || isButton(each);
	});
}

function isButton(element) {
	return (element.tagName == "INPUT"
    	&& (element.type == "submit" || element.type == "reset"))
						|| element.tagName == "BUTTON";
}

function isLink(element) {
    return element.tagName == "A";
}


/*
	clicks on a link or on a submit button that includes text
*/
function click(textOrElement) {
	if (isButton(textOrElement)) { clickButton(textOrElement) }
	if (isLink(textOrElement)) { clickLink(textOrElement); }
	if (typeof(textOrElement == "string")) {
		Try.these(
  			clickLink(textOrElement),
  			clickButton(textOrElement, "submit"),
  			clickButton(textOrElement, "reset"));	
	 } 
	 return true;
}


function clickTextIn(text, array) {
    return click(findIn(text, clickableIn(array))[0]);
}

/* 
   "Clicks" on the first Link that includes the text linktText
*/
function clickLink(textOrElement) {
	if (typeof(textOrElement) == "string") {
	    return followLink(findIn(textOrElement, $$("a"))[0]);
	} else {
	    return followLink(textOrElement);
	}
}


function findLinks(linkText) {
  return $A($$("a")).select(function(each) { 
     return each.innerHTML.indexOf(linkText) >= 0
		 })
}

function followLink(linkElement) {
  try {
    if (linkElement.onclick) linkElement.onclick();
	  else window.location=linkElement.href;
	} 
	catch (er) {  }
	return true;
}

function clickButton(button) {
    try { return button.click(); }
		catch(er) {  }
}

/* 
   Clicks the button with the buttonText
*/
function clickButton(buttonText, buttonType) {
	try {
		(findButtons(buttonText, buttonType).concat(findButtons2(buttonText, buttonType))[0]).click();
		return true;
	} catch(er) {  } 
}

function findButtons(buttonText, buttonType) {
  return $A($$("input[type="+buttonType+"]")).select(function(each) { 
     return each.value.indexOf(buttonText) >= 0;
		 })
}
function findButtons2(buttonText, buttonType) {
	return $A($$("button[type="+buttonType+"]")).select(function(each) { 
		return each.innerHTML.indexOf(buttonText) >= 0;
	})
}'! !

!ALibrary methodsFor: 'accessing-scripts' stamp: 'pmm 12/6/2007 21:57'!
distanceJs
	"distance(element1, element2)	returns the calculated distance value, optimized for finding form fields that belong to a text element."

	^ '

var linePreference = 4;
var rightPreference = 5.


function distance(element1, element2) {
    var gEuklid = 1;
		var gOrder = 1;
		var normEuklid = 30;
		var normOrder = 2;
		return gEuklid * euklidDistance(element1, element2) / normEuklid
					 + gOrder * orderDistance(element1, element2) / normOrder;
}

/* 
	 returns the geometrical distance, x shrunk by linePreference
	 
 */
function euklidDistance(element1, element2) {
    var xDist = xDiff(element1, element2)/linePreference;
		var yDist = yDiff(element1, element2);
		return Math.sqrt(xDist*xDist + yDist*yDist);
}


function xDiff(element1, element2) {
    return Position.cumulativeOffset(element2)[0] - Position.cumulativeOffset(element1)[0];
}


function yDiff(element1, element2) {
    return Position.cumulativeOffset(element2)[1] - Position.cumulativeOffset(element1)[1];
}


/* 
   calculates a logical distance where the number of html-tags is counted.
	 if b is before a, the distance is multiplied by rightPreference.
	 orderDistance(x,y) !!= orderDistance(y,x)
	
 */
 function orderDistance(a, b) {
     var ia = all().indexOf(a);
		 var ib = all().indexOf(b);
		 if (ib - ia < 0) return (ia - ib)*rightPreference;
		 else return ib - ia;
 }

'! !

!ALibrary methodsFor: 'accessing-scripts' stamp: 'pmm 12/6/2007 21:57'!
findJs
	"find(text)			Finds all most inner elements with the given text inside.
	findIn(text,array)	Returns those (most inner) elements of array that contain text.
	all()				all elements in the body."

 	^ '

function all() {
		return $$("body *");
}


function find(text) {
    return findIn(text, all());
}


function findIn(text, array) {
     var containing = $A(array).select(function(each) { 
	   try { return (
		 				each.innerHTML.indexOf(text) >= 0
						|| each.value.indexOf(text) >= 0
						|| $F(each).indexOf(text) >= 0
		 )} catch (er) { return false }
		 
		 }) ;
		 return mostInner(containing);
}



function mostInner(elements) {
		var result = elements;
    for (var i = 1; i < elements.length; i++) {
				if (elements[i].childOf(elements[i-1])) result[i-1] = 0;
		}
		result = result.select(function(each) {
		    return each !!= 0;
		});
		return result;
}

'! !

!ALibrary methodsFor: 'accessing-scripts' stamp: 'pmm 12/6/2007 21:58'!
inputForJs
	"inputNear(text)							returns the form field that belongs to text.
	findInputFor(labelElement)				returns the form field that is nearest to the labelElement.
	findInputForWith(labelElement, metric)	is the same, but an own metric function can be given to use instead of the albatross distance function."

	^ '


function findInputFor(labelElement) {
    var allInputs = allInputElements();
		if (allInputs.length == 0) return null;
		var nearest = allInputs[0];
		allInputs.each(function(each) {
		     if (distance(labelElement, each) < distance(labelElement, nearest)) nearest = each;
		});
		return nearest;
}

function findInputForWith(labelElement, metric) {
    var allInputs = allInputElements();
		if (allInputs.length == 0) return null;
		var nearest = allInputs[0];
		allInputs.each(function(each) {
		     if (metric(labelElement, each) < metric(labelElement, nearest)) nearest = each;
		});
		return nearest;
}


function allInputElements() {
    return $$("input[type=text]").concat(
				$$("input[type=password]"), 
				$$("textarea"),
				$$("input[type=radio]"),
				$$("input[type=checkbox]"),
				$$("select"));
}


function inputNear(text) {
    return findInputFor(find(text)[0])
}



'! !

!ALibrary methodsFor: 'accessing-scripts' stamp: 'al 1/6/2008 20:39'!
prototypeJs
	^ SULibrary default prototypeJs! !

!ALibrary methodsFor: 'accessing' stamp: 'al 1/6/2008 20:56'!
selectorsToInclude
	^#(
		prototypeJs
		findJs
		clickJs
		distanceJs
		inputForJs
		testExistsJs
		valueJs
	)! !

!ALibrary methodsFor: 'accessing-scripts' stamp: 'pmm 12/6/2007 21:58'!
testExistsJs
	"textExists(text)			returns true if text exists on the page.
	textExistsIn(text, array)	returns true if text exists in an element of array."

	^'

function textExists(text) {
    return textExistsIn(text, all());
}

function textExistsIn(text, array) {
    found = findIn(text, array);
    return (found !!= null && found.length > 0);
}

'! !

!ALibrary methodsFor: 'accessing-scripts' stamp: 'al 1/7/2008 11:00'!
valueJs
	"valueFor(labelText)				returns the value of the form field that belongs to the labelText.
	$V(element) or value(element)	returns the value of the element.
	enterFor(value, labelText)		enters value into the form field that belongs to the labelText.
	enterValue(value, element)		enters value into element.
	valueOfId(id)					value of the element with id.
	enterForId(value, id)			enters value into element with id.
"

	^'
function valueOfId(id) {
    elem = $(id);
    return $V(elem);
}

function enterForId(value, id) {
    elem = $(id);
    return enterValue(value, elem);
}

var $V = value;


/*
Gives you the value of every kind of form-elements
and other elements
*/
function value(elem) {
    if (elem == null) return null;
    tag = elem.tagName.toLowerCase();
		if("input" == tag) {
        if("checkbox" == elem.type
				|| "radio" == elem.type) {
				    return elem.checked;
				}
		}
		if ("select" == tag) {
		    if (elem.multiple) {
				   //Array mit den innerHTMLs aller gewhlten Optionen
					 value = new Array();
					 $A(elem.options).each(function(option){
					     if (option.selected) value.push(option.innerHTML);
					 });
					 return value;
				}
				else {
				   //innerHTML der gewhlten option. (angezeigter gewhlter Text)
					 value = null;
					 $A(elem.options).each(function(option) {
					     if (option.selected) value = option.innerHTML;
					 });
					 return value;
				}
		}
		if("input" == tag ||
		   "textarea" == tag ||
			 "button" == tag) {
			 return $F(elem); //.value
		}
		
		// For all other elements:
		return elem.innerHTML;
}


function enterValue(value, elem) {
	if (elem == null) return false;
    tag = elem.tagName.toLowerCase();
		
		
	// select: the exact string is required!!
	if("select" == tag) { // value is a single element or an array that contains what should be selected
		if ((value.toString())[0] == "[") value = eval(value); 
		values = [].concat(value);
		$A(elem.options).each(function(option) {
			option.selected = values.include(option.innerHTML);
		});	
	} 
	
	// input type=checkbox/radio
	if("input" == tag) {
	   	if ("checkbox" == elem.type || "radio" == elem.type) {
			if (value == "true") elem.checked = true;
			if (value == "false") elem.checked = false;		
		} else {
			// input type=text/password...
			elem.value = value;
		}
	}
		
	if("button" == tag || "textarea" == tag) {
		elem.value = value;
	}
	
	// for all:
	if (elem.onclick) elem.onclick();
	if (elem.onchange) elem.onchange();
	return true;		
}


function enterFor(value, labelText) {
    elem = inputNear(labelText);
	if (elem == null) return false;
	return enterValue(value, elem);
}


function valueFor(labelText) {
    elem = inputNear(labelText);
	if (elem == null) return false;
	return $V(elem);
}
'! !

Object subclass: #ABrowser
	instanceVariableNames: 'inQueue outQueue applicationUrl driverUrl resultType'
	classVariableNames: 'Timeout'
	poolDictionaries: ''
	category: 'Albatross'!

!ABrowser commentStamp: '<historical>' prior: 0!
I let you simulate a web page visitor. You can tell me to open the testApplication, click on buttons, get values of form fields, enter text and much more. I will organize the technical aspects of all that for you and give you back the results of these actions.!

!ABrowser class methodsFor: 'as yet unclassified' stamp: 'al 6/16/2006 10:08'!
inQueue: in outQueue: out
	^self new
		inQueue: in outQueue: out;
		yourself! !

!ABrowser class methodsFor: 'as yet unclassified' stamp: 'ab 8/12/2006 15:50'!
timeout
	^ Timeout! !

!ABrowser methodsFor: 'accessing' stamp: 'al 6/16/2006 10:08'!
applicationUrl	
	^applicationUrl! !

!ABrowser methodsFor: 'accessing' stamp: 'al 6/16/2006 10:24'!
applicationUrl: anUrl driverUrl: anotherUrl
	applicationUrl := anUrl.
	driverUrl := anotherUrl! !

!ABrowser methodsFor: 'private' stamp: 'al 10/28/2006 15:30'!
ask: aSUStream
	^self ask: aSUStream type: #asString! !

!ABrowser methodsFor: 'private' stamp: 'al 1/6/2008 22:13'!
ask: aSUStream type: aSymbol 
	"aSymbol determines the type to which the result is converted,
	and aSUStream is a JavaScript expression"
	
	self resultType: aSymbol. 
	(Delay forSeconds: 0.1) wait.
	^self send: (SUScript new
		add: (SURequest new
			url: self driverUrl;
			addParameter: 'result' -> aSUStream))! !

!ABrowser methodsFor: 'testing' stamp: 'al 10/28/2006 15:04'!
askJS: aString
	^self ask: (SUStream on: aString)! !

!ABrowser methodsFor: 'actions' stamp: 'al 10/28/2006 15:19'!
back
	^self send: (SUStream new
		nextPutAll: 'history.back()') ! !

!ABrowser methodsFor: 'actions' stamp: 'al 10/28/2006 15:19'!
click: aStringOrElement 
	^self send: (SUStream new
		nextPutAll: 'click';
		argument: aStringOrElement)! !

!ABrowser methodsFor: 'actions' stamp: 'al 1/5/2008 19:52'!
click: aText in: aCssSelector
	self click: (
		self firstFind: aText in: (
			self clickableIn: (self css: aCssSelector)))
	! !

!ABrowser methodsFor: 'actions' stamp: 'al 1/5/2008 20:36'!
clickButton: aStringOrElement 
	^self send: (SUStream new
		nextPutAll: 'clickButton';
		argument: aStringOrElement)! !

!ABrowser methodsFor: 'actions' stamp: 'al 1/5/2008 20:36'!
clickLocal: aStringOrElement 
	"If the click does not open a new page, use this method"
	
	^self ask: (SUStream new
		nextPutAll: 'click';
		argument: aStringOrElement)! !

!ABrowser methodsFor: 'actions' stamp: 'al 1/5/2008 20:36'!
clickLocal: aText in: aCssSelector
	"If the click does not open a new page, use this method"
	
	self clickLocal: (
		self firstFind: aText in: (
			self clickableIn: (self css: aCssSelector)))! !

!ABrowser methodsFor: 'finding elements' stamp: 'al 10/28/2006 15:15'!
clickableIn: anArray
	"Gives all links and buttons of the array"
	^ SUStream new
		nextPutAll: 'clickableIn';
		argument: anArray! !

!ABrowser methodsFor: 'testing' stamp: 'ab 8/12/2006 15:27'!
confirm: aString
	^self ask: (SUStream new nextPutAll: 'confirm'; argument: aString) ! !

!ABrowser methodsFor: 'finding elements' stamp: 'al 10/28/2006 15:15'!
css: aString 
	"e.g., 'div#page p.summary img' gives all images in p-blocks with class=summary that are in a div named page. Write a css selector as argument for this message.
	This is the prototype $$ function."

	^(SUStream new)
		nextPutAll: '$$';
		argument: aString! !

!ABrowser methodsFor: 'accessing' stamp: 'al 6/16/2006 10:12'!
driverUrl
	^driverUrl! !

!ABrowser methodsFor: 'actions' stamp: 'al 1/6/2008 16:16'!
end
	"Send a response that does nothing and hence stops the interaction"
	
	outQueue nextPut: SUFunction new printString.
	(Delay forSeconds: 2) wait! !

!ABrowser methodsFor: 'actions' stamp: 'al 10/28/2006 15:20'!
enter: value for: label
	^self ask: (SUStream new
		nextPutAll: 'enterFor';
		arguments: {value asString. label})! !

!ABrowser methodsFor: 'actions' stamp: 'al 10/28/2006 15:20'!
enter: value into: element
	"self enter: 'hello' into: (self get: 1 in: (self css: '.contents input[type=text]'))
	this will fill hello into the first textinput in the div with the contents class.
	it is useful when input fields have no label"

	^self ask: (SUStream new
		nextPutAll: 'enterValue';
		arguments: {value asString. element})! !

!ABrowser methodsFor: 'finding elements' stamp: 'al 1/5/2008 19:26'!
find: aString
	^ self find: aString in: (self css: 'body *')! !

!ABrowser methodsFor: 'finding elements' stamp: 'al 10/28/2006 15:13'!
find: aString in: anArray
	^ SUStream new
		nextPutAll: 'findIn("'; nextPutAll: aString; nextPutAll: '", ';
		nextPutAll: anArray printString;
		nextPutAll: ' )'.! !

!ABrowser methodsFor: 'finding elements' stamp: 'ab 8/22/2006 21:33'!
firstFind: aString
	^ self get: 1 in: (self find: aString)! !

!ABrowser methodsFor: 'finding elements' stamp: 'ab 8/22/2006 21:34'!
firstFind: aString in: anArray
	^ self get: 1 in: (self find: aString in: anArray)! !

!ABrowser methodsFor: 'actions' stamp: 'al 10/28/2006 15:20'!
forward
	^self send: (SUStream new
		nextPutAll: 'history.forward()')! !

!ABrowser methodsFor: 'finding elements' stamp: 'ab 8/22/2006 11:33'!
get: aNumber in: anArray
	^(SUStream new)
		nextPutAll: anArray asString;
		nextPutAll: '[';
		nextPutAll: (aNumber - 1) printString;
		nextPutAll: ']'.! !

!ABrowser methodsFor: 'finding elements' stamp: 'ab 8/21/2006 17:54'!
id: id 
	"This is the prototype $ function"

	^(SUStream new)
		nextPutAll: '$';
		argument: id! !

!ABrowser methodsFor: 'testing' stamp: 'al 10/28/2006 15:33'!
idOf: anElement
	^self ask: (SUStream new
		nextPutAll: anElement;
		nextPutAll: '.id')! !

!ABrowser methodsFor: 'accessing' stamp: 'al 6/16/2006 10:08'!
inQueue: in outQueue: out
	inQueue := in.
	outQueue := out.! !

!ABrowser methodsFor: 'actions' stamp: 'al 6/16/2006 10:25'!
open
	ExternalWebBrowser openOnUrl: self applicationUrl! !

!ABrowser methodsFor: 'private' stamp: 'al 1/5/2008 17:05'!
receiveOrTimeout
	| proc result sem typedResult |
	
	sem := Semaphore new.
	proc := [
		result := inQueue next.
		sem signal ] fork.
	sem waitTimeoutSeconds: self class timeout.
	result ifNil: [
		proc terminate.
		self error: 'Timed out receiving reply' ].
	
	typedResult := result.
	resultType isNil
		ifFalse: [ typedResult := result perform: resultType ] 
		ifTrue: [ [ typedResult := Object readFrom: result ] ifError: [
			typedResult := result asString ] ].
	self resultType: nil.
	^ typedResult! !

!ABrowser methodsFor: 'accessing' stamp: 'ab 8/12/2006 15:12'!
resultType
	^ resultType ! !

!ABrowser methodsFor: 'accessing' stamp: 'ab 8/12/2006 15:12'!
resultType: aSymbol
	resultType := aSymbol! !

!ABrowser methodsFor: 'private' stamp: 'al 10/28/2006 15:03'!
send: anObject
	outQueue nextPut: (String streamContents: [ :stream |
		anObject printOn: stream ]).
	^self receiveOrTimeout! !

!ABrowser methodsFor: 'private' stamp: 'ab 8/21/2006 14:42'!
send: anObject type: aSymbol
	self resultType: aSymbol.
	^self send: anObject! !

!ABrowser methodsFor: 'actions' stamp: 'al 10/28/2006 15:17'!
sendJS: aString
	^self send: (SUStream on: aString)! !

!ABrowser methodsFor: 'testing' stamp: 'al 10/28/2006 15:45'!
textExists: aString
	^self ask: (SUStream new
		nextPutAll: 'textExists';
		argument: aString asString) type: #asBoolean! !

!ABrowser methodsFor: 'testing' stamp: 'al 10/28/2006 15:59'!
textExists: aString in: aCssSelector
	^self ask: (SUStream new
		nextPutAll: 'textExistsIn("';
		nextPutAll: aString asString;
		nextPutAll: '", ';
		nextPutAll: (self css: aCssSelector) printString;
		nextPutAll: ' )') type: #asBoolean
! !

!ABrowser methodsFor: 'accessing' stamp: 'ab 8/22/2006 14:11'!
timeout
	^Timeout! !

!ABrowser methodsFor: 'accessing' stamp: 'ab 8/12/2006 15:50'!
timeout: anInteger
	Timeout := anInteger! !

!ABrowser methodsFor: 'testing' stamp: 'al 10/28/2006 15:33'!
valueFor: label
	"still with problems"
	
	^self ask: (SUStream new
		nextPutAll: 'valueFor';
		argument: label)! !

!ABrowser methodsFor: 'testing' stamp: 'al 10/28/2006 15:33'!
valueOf: anElement
	^self ask: (SUStream new
		nextPutAll: '$F';
		argument: anElement)! !

!ABrowser methodsFor: 'testing' stamp: 'al 10/28/2006 15:33'!
valueOfId: id
	^self ask: (SUStream new
		nextPutAll: 'valueOfId';
		argument: id)! !

WAComponent subclass: #AComponentWrapper
	instanceVariableNames: 'testComponent'
	classVariableNames: 'MyTest'
	poolDictionaries: ''
	category: 'Albatross'!

!AComponentWrapper commentStamp: '<historical>' prior: 0!
I am the testComponent wrapper. I send the albatross javascripts along with it. The external browser opens me on .../seaside/albatross!

!AComponentWrapper class methodsFor: 'server configuration' stamp: 'mberth 2/27/2008 12:12'!
applicationUrl
	^self rootUrl , 'albatross'.! !

!AComponentWrapper class methodsFor: 'testing' stamp: 'AB 6/6/2006 16:38'!
canBeRoot
	^ true! !

!AComponentWrapper class methodsFor: 'server configuration' stamp: 'mberth 2/27/2008 12:12'!
driverUrl
	^self rootUrl , 'driver'! !

!AComponentWrapper class methodsFor: 'class initialization' stamp: 'al 1/5/2008 17:56'!
initialize
	(self registerAsApplication: 'albatross')
		addLibrary: ALibrary! !

!AComponentWrapper class methodsFor: 'class initialization' stamp: 'al 1/5/2008 19:02'!
initializeWith: anApplication for: aTestCase
	| application |
	application := self registerAsApplication: 'albatross'.
	application addLibrary: ALibrary.
	anApplication libraries do: [ :each | application addLibrary: each ].
	self myTest: aTestCase! !

!AComponentWrapper class methodsFor: 'class initialization' stamp: 'ab 8/9/2006 16:29'!
myTest: test
	MyTest := test! !

!AComponentWrapper class methodsFor: 'server configuration' stamp: 'mberth 2/27/2008 12:16'!
rootUrl
	"The URL of the seaside installation."
	^'http://localhost:8080/seaside/'! !

!AComponentWrapper methodsFor: 'accessing' stamp: 'ab 8/9/2006 18:24'!
children
	^Array with: self testComponent! !

!AComponentWrapper methodsFor: 'accessing' stamp: 'mberth 2/27/2008 11:58'!
driverUrl
	^self class driverUrl ! !

!AComponentWrapper methodsFor: 'initialize-release' stamp: 'al 1/5/2008 18:48'!
initialize
	super initialize.
	testComponent := MyTest createTestComponent ! !

!AComponentWrapper methodsFor: 'accessing' stamp: 'ab 8/9/2006 16:28'!
myTest: test
	MyTest := test! !

!AComponentWrapper methodsFor: 'rendering' stamp: 'ab 8/9/2006 18:34'!
renderContentOn: html 
	"self renderTopOn: html."

	self renderTestComponentOn: html.
	self renderScriptOn: html! !

!AComponentWrapper methodsFor: 'rendering' stamp: 'pmm 1/3/2008 14:57'!
renderScriptOn: html
	html script: (html request
		url: self driverUrl;
		addParameter: 'start' -> true)! !

!AComponentWrapper methodsFor: 'rendering' stamp: 'ab 8/9/2006 18:24'!
renderTestComponentOn: html 
	html render: self testComponent! !

!AComponentWrapper methodsFor: 'accessing' stamp: 'pmm 1/3/2008 14:51'!
states
	^ Array with: self! !

!AComponentWrapper methodsFor: 'accessing' stamp: 'ab 8/9/2006 18:24'!
testComponent
	^testComponent! !

!AComponentWrapper methodsFor: 'rendering' stamp: 'ab 9/22/2006 12:02'!
updateRoot: aRoot
	super updateRoot: aRoot.
	aRoot title: 'Albatross'.
	! !

TestCase subclass: #ATestCase
	instanceVariableNames: 'browser testComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Albatross'!

!ATestCase commentStamp: '<historical>' prior: 0!
I am the superclass of your Albatross tests. Please write a createTestComponent method to make an instance of the component you want to test. Then write tests!!!

ATestCase subclass: #APierTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Albatross-Tests'!

!APierTest methodsFor: 'accessing' stamp: 'al 1/5/2008 20:28'!
createTestComponent
	^ PRPierFrame on: (PRContext kernel: (PRKernel named: 'Pier Test' ))
! !

!APierTest methodsFor: 'testing' stamp: 'al 1/6/2008 15:52'!
makeSushiShop
	self assert: (browser textExists: 'Welcome to Pier (formerly called SmallWiki 2)').
	browser
		click: 'Edit'; 
		enter: 'Albatross Sushi Shop' for: 'Title';
		enter: 'This is the great Albatross Sushi Shop!! 
+Sushi+' into:  (browser get: 1 in: (browser css: '.wiki'));
		click: 'Save';
		click: 'Sushi' in: '.contents *';	
		enter: 'Component' for: 'Type';
		click: 'Add';
		enter: 'Store' for: 'Component Class';
		click: 'Save';
		click: 'Albatross Sushi Shop'.
	self assert: (browser textExists: 'sushiNet online store').


	
	
	! !

!APierTest methodsFor: 'accessing' stamp: 'al 1/5/2008 20:28'!
subjectApplication
	^WADispatcher default entryPointAt: '/pier/'! !

!APierTest methodsFor: 'testing' stamp: 'al 1/6/2008 21:49'!
testEditPage
	"self debug: #testEditPage"

	self assert: (self browser textExists: 'Pier Test').
	self assert: (browser textExists: 'Welcome to Pier (formerly called SmallWiki 2)').
	browser click: 'Edit'.
	browser enter: 'Hello world!!' for: 'Title'.
	browser
		enter: 'This is the first Albatross Pier test in the world!!'
		into: (browser get: 1 in: (browser css: '.wiki')).
	browser click: 'Save'.
	self assert: (browser textExists: 'Hello world!!').
	self assert: (browser textExists: 'the first Albatross Pier test')! !

!APierTest methodsFor: 'testing' stamp: 'al 1/6/2008 16:04'!
testSushiShop
	"self debug: #testSushiShop"

	self makeSushiShop.
	browser click: 'Browse' in: '.contents *'.
	self assert: (browser textExists: 'Aji').
	browser
		click: 'Akami Maguro';
		click: 'Add To Cart';
		click: 'Add To Cart';
		click: 'Browse' in: '.contents *'.
	self assert: (browser textExists: '$3.00').

	
	
	! !

ATestCase subclass: #AScriptaculousTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Albatross-Tests'!

!AScriptaculousTest methodsFor: 'accessing' stamp: 'al 1/5/2008 20:28'!
subjectApplication
	^WADispatcher default entryPointAt: '/tests/scriptaculous/'! !

!AScriptaculousTest methodsFor: 'testing' stamp: 'al 1/5/2008 18:51'!
testCounter
	"self debug: #testCounter"
	self assert: (browser textExists: 'Counter').
	self assert: (browser textExists: 0 in: '#counter_id8').
	browser clickLocal: '++'.
	self assert: (browser textExists: 1 in: '#counter_id8').
	browser clickLocal: '--'; clickLocal: '--'.
	self assert: (browser textExists: -1 in: '#counter_id8').
	! !

!AScriptaculousTest methodsFor: 'testing' stamp: 'al 1/5/2008 18:53'!
testRadioAndCheckBoxes
	"self debug: #testRadioAndCheckBoxes"

	browser click: 'Form'.
	self assert: (browser textExists: 'Check-Box').
	browser enter: true for: 'Check-Box'.
	self assert: (browser textExists: 'true' in: '.model').
	browser enter: true into: (browser get: 2 in: (browser css: 'input[type=radio]')).


	"the id can change easily, but it is the easiest way to identify the location of the result"
	self assert: (browser textExists: 2 in: '#id21').! !

!AScriptaculousTest methodsFor: 'testing' stamp: 'al 10/28/2006 14:39'!
testSelect
	browser click: 'Form'.
	self assert: (browser textExists: 'Check-Box').
	browser enter: 7 for: 'Select-List'.
	self assert: (browser textExists: 7 in: '.model').
	browser enter: '["6","8"]' for: 'Multi'.
	self assert: (browser textExists: 68 in: '.model').
	
! !

!AScriptaculousTest methodsFor: 'testing' stamp: 'al 1/5/2008 19:31'!
testTextInputAndArea
	"self debug: #testTextInputAndArea"
	
	browser click: 'Form'.
	self assert: (browser textExists: 'Check-Box').
	browser enter: 'huhu' for: 'Text-Input'.
	self assert: (browser textExists: 'huhu').
	browser clickLocal: 'Submit'.
	browser enter: 'mmmmmmm' for: 'Text-Input'.
	self assert: (browser textExists: 'huhu' in: '.model').

	browser enter: 'Some cool text to test the text area!!' for: 'Text-Area'.
	browser clickLocal: (browser get: 2 in: (browser find: 'Submit')).
	browser enter: 'Forget what I said, I enter another text.' for: 'Text-Area'.
	self assert: (browser textExists: 'Some cool text').! !

ATestCase subclass: #ASeasideTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Albatross-Tests'!

!ASeasideTests methodsFor: 'accessing' stamp: 'al 1/6/2008 14:57'!
subjectApplication
	^WADispatcher default entryPointAt: '/tests/alltests/'! !

!ASeasideTests methodsFor: 'running' stamp: 'mberth 2/27/2008 11:46'!
testBatch
	"self debug: #testBatch"

	browser click: 'Batch'.
	self assert: (browser textExists: 'Array').
	browser click: 'Q'.
	self assert: (browser textExists: 'QuickStack').
	browser click: '&gt;&gt;'.
	self assert: (browser textExists: 'RunArray').! !

!ASeasideTests methodsFor: 'running' stamp: 'al 1/6/2008 15:17'!
testButton
	"self debug: #testButton"

	browser click: 'Button'.
	self assert: (browser textExists: 'a text').
	
	browser enter: 'foo' for: 'Input'.
	browser click: 'Submit'.
	self assert: (browser textExists: 'foo').
	
	browser enter: 'bar' for: 'Input'.
	browser clickLocal: 'Reset'.
	browser click: 'Submit'.
	self assert: (browser textExists: 'foo').
	! !

!ASeasideTests methodsFor: 'running' stamp: 'al 1/6/2008 15:36'!
testConvenience
	"self debug: #testConvenience"

	browser click: 'Convenience'.
	self assert: (browser textExists: 'What''s your favorite Cheese').
	
	browser enter: 'Sbrinz' into: (browser get: 1 in: (browser css: 'select')).
	browser click: 'Ok'.
	self assert: (browser textExists: 'Is Sbrinz your favorite cheese').
	browser click: 'Yes'.
	browser click: 'Ok'.
	self assert: (browser textExists: 'What''s your favorite Cheese').! !

!ASeasideTests methodsFor: 'running' stamp: 'al 1/6/2008 14:55'!
testStartup
	self assert: (browser textExists: 'Functional Seaside Test Suite')! !

!ATestCase class methodsFor: 'testing' stamp: 'pmm 1/3/2008 14:44'!
isAbstract
	^self name = #ATestCase! !

!ATestCase methodsFor: 'accessing' stamp: 'ab 8/21/2006 14:47'!
application
	^ WADispatcher default entryPointAt: 'albatross'.! !

!ATestCase methodsFor: 'accessing' stamp: 'al 6/14/2006 10:01'!
browser
	^browser! !

!ATestCase methodsFor: 'accessing' stamp: 'al 1/6/2008 14:52'!
createTestComponent
	^ self subjectApplication rootComponent new! !

!ATestCase methodsFor: 'accessing' stamp: 'mberth 2/27/2008 12:00'!
setUp
	| handler |
	handler := ARequestHandler default reset; yourself.
	AComponentWrapper initializeWith: self subjectApplication for: self.
	
	browser := handler browser
		applicationUrl: AComponentWrapper applicationUrl 
		driverUrl: AComponentWrapper driverUrl.
	
	browser timeout: 10.
	browser open.
	browser timeout: 5.
	browser receiveOrTimeout.! !

!ATestCase methodsFor: 'accessing' stamp: 'al 1/5/2008 18:40'!
subjectApplication
	^ self subclassResponsibility ! !

!ATestCase methodsFor: 'running' stamp: 'al 1/5/2008 18:49'!
tearDown
	super tearDown.
	self browser end! !
AComponentWrapper initialize!
